# =================================================================================================
#<profile4xi profile = "12" />
#<program4xi program = "platformids4xi.py">
#<abstract4xi abstract = "provides Platform ID information"/>
#<refer4xi reference = "Platform ID"/>
#<verify4xi verification = "10" target = "platformids4xi5test.py">
#<state4xi status = "ACK4review; ACK4tagging; ACK4moduletesting; ACK4systemtesting; [Rel 7.21]"/>
# =================================================================================================

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'PlatformID4Xi',
            'init2platformids4xi',
            'get2platformids4xi',
            'set2platformids4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread   

from decimal import *
#"
#/>


# -------------------------------------------------------------------------------------------------
# Scope4Xi imports                               
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
import version4xi
 
#"
#/>

# -------------------------------------------------------------------------------------------------
# Multiprocessing Imports                          
# -------------------------------------------------------------------------------------------------
#<process4xi process = "
import _multiprocessing
#"
#/>


# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "
from ace_object4xi import ace_object4xi
from print4xi import print4xi
from time4xi import time4xi
from reason_object4xi import reason_object4xi
from sense_object4xi import sense_object4xi
#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "
global ids2platform4xi
       
#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "

#"
#"/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "init2platformids4xi" usage = "
#    task4init2platformids = {}
#    
#    task4init2platformids['max2entries'] =        n1                                                               # n1   = the number of cl_platform_id entries that can be added to platforms
#    task4init2platformids['list2platforms'] =     list,                                                            # list = a list of OpenCL platforms found
#    task4init2platformids['available2platform'] = n2                                                               # n2   = the number of OpenCL platforms available
#
#    try:                               
#        response4init2platformids = init2platformids4xi(task4init2platformids)                                     # or response2xi = init2platformids4xi() <-- let the system decide!
#                                                                                                                   
#                                                                                                                   response4init2platformids = 
#                                                                                                                      {'max2entries':        1,
#                                                                                                                       'list2platforms':     ['DragonXi'],
#                                                                                                                       'available2platform': 1, 
#                                                                                                                       'code':               SUCCESS4XI # OTHER OPTIONS: INVALID2VALUE4XI, OUT2HOSTMEMORY4XI
#                                                                                                                       }                 
#    except:
#        ... 
#                          
#">

# -------------------------------------------------------------------------------------------------   
def init2platformids4xi(task4init2platformids=None):

    '''
    initializes platformids4xi
    '''
    global ids2platform4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/3)           
    # -----------------------------------------------------------------------------------------          
    class2print = "init2platformids4xi"
    method2print = "init2platformids4xi"

    message2print = "{(Step 1/3a) started" + "; init2platformids4xi-started: " + str(init2platformids4xi)  + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              # <function init2platformids4xi at 0x00000000029A7BC8>; time: 01:33:21 04/21/11 Pacific Daylight Time} 
  
             
    message2print = "{(Step 1/3b) passed" + "; task4init2platformids-to-init2platformids4xi: " + str(task4init2platformids) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              # None
             
    if task4init2platformids is None:
        task4init2platformids = {}
        task4init2platformids['max2entries']        = 1                                                             # the number of cl_platform_id entries that can be added to platforms
        task4init2platformids['list2platforms']     = ['DragonXi']                                                  # a list of OpenCL platforms found
        task4init2platformids['available2platform'] = 1                                                             # the number of OpenCL platforms available
 
    
    ids2platform4xi = {}
                    
    # -----------------------------------------------------------------------------------------
    # (Step 2/3)       
    # -----------------------------------------------------------------------------------------                   
    message2print = "{(Step 2A/3) try" + "; task4init2platformids-try-by-init2platformids4xi: " + str(task4init2platformids)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                              # {'list2platforms': ['DragonXi'], 'available2platform': 1, 'max2entries': 1}; time: 01:33:21 04/21/11 Pacific Daylight Time}
    
    code2ack  = ' '
    code2nack = ' '
    
    try:
        # -----------------------------------------------------------------------------------------
        # MAXIMUM ENTRIES
        # ----------------------------------------------------------------------------------------- 
        if task4init2platformids ['max2entries'] is None:
            ids2platform4xi['max2entries'] = 1
            message2print = "{(Step 2B/3) initialized" + "; max2entries-set-by-init2platformids4xi to: " + str(ids2platform4xi ['max2entries'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            code2ack  = code2ack + '2B-'
        else:
            ids2platform4xi['max2entries'] = task4init2platformids ['max2entries']
            message2print = "{(Step 2C/3) initialized" + "; max2entries-set-by-init2platformids4xi to: " + str(ids2platform4xi ['max2entries'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                      # 1
            code2ack  = code2ack + '2C-'
    except:
        message2print = "{(Step 2Z1/3) failed" + "; ids2platform4xi-failed-by-init2platformids4xi: " + str(ids2platform4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        code2nack  = code2nack + '2Z1-'
        
    try:
        # -----------------------------------------------------------------------------------------
        # MAXIMUM ENTRIES
        # -----------------------------------------------------------------------------------------               
        if task4init2platformids ['max2entries'] == 0:
            ids2platform4xi ['max2entries'] = 1
            message2print = "{(Step 2D/3) initialized" + "; max2entries-set-by-init2platformids4xi to: " + str(ids2platform4xi ['max2entries'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            code2ack  = code2ack + '2D-'
        else:
            ids2platform4xi ['max2entries'] = task4init2platformids ['max2entries']
            message2print = "{(Step 2E/3) initialized" + "; max2entries-set-by-init2platformids4xi to: " + str(ids2platform4xi ['max2entries'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                       # 1
            code2ack  = code2ack + '2E-'                                                                                  
    except: 
        message2print = "{(Step 2Z2/3) failed" + "; ids2platform4xi-failed-by-init2platformids4xi: " + str(ids2platform4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)              
        code2nack  = code2nack + '2Z2-'
            
    try: 
        # -----------------------------------------------------------------------------------------
        # LIST OF PLATFORMS
        # -----------------------------------------------------------------------------------------                                        
        ids2platform4xi ['list2platforms'] = task4init2platformids ['list2platforms']
        message2print = "{(Step 2F/3) initialized" + "; list2platforms-set-by-init2platformids4xi to: " + str(ids2platform4xi ['list2platforms'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          # ['DragonXi']
        code2ack  = code2ack + '2F-'
    except:
        message2print = "{(Step 2Z3/3) failed" + "; ids2platform4xi-failed-by-init2platformids4xi: " + str(ids2platform4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
        code2nack  = code2nack + '2Z3-'
                
    try: 
        # -----------------------------------------------------------------------------------------
        # AVAILABLE PLATFORMS
        # -----------------------------------------------------------------------------------------            
        ids2platform4xi ['available2platform'] = task4init2platformids ['available2platform']            
        message2print = "{(Step 2G/3) initialized" + "; available2platform-set-by-init2platformids4xi to: " + str(ids2platform4xi ['available2platform'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          # 1
        code2ack  = code2ack + '2G-'
    except:
        message2print = "{(Step 2Z4/3) failed" + "; ids2platform4xi-failed-by-init2platformids4xi: " + str(ids2platform4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)     
        code2nack  = code2nack + '2Z4-'    

        
    # -----------------------------------------------------------------------------------------
    # (Step 3/3)           
    # -----------------------------------------------------------------------------------------
    ids2platform4xi ['ack2return']  = code2ack
    ids2platform4xi ['nack2return'] = code2nack
    
    message2print = "{(Step 3/3) returning" + "; ids2platform4xi-returning-by-init2platformids4xi: " + str(ids2platform4xi) + "; time: " + time4xi() + "}"  
    print4xi(class2print, method2print, message2print)                                                              # {   'list2platforms': ['DragonXi'], 
                                                                                                                    #         'ack2return': ' 2C2E2F2G', 
                                                                                                                    #        'nack2return': ' ', 
                                                                                                                    # 'available2platform': 1, 
                                                                                                                    #        'max2entries': 1
                                                                                                                    # }; time: 01:50:40 04/27/11 Pacific Daylight Time}

    return ids2platform4xi
            
#</function4xi>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "set2platformids4xi" usage = "
#    task4set2platformids =
#      {'max2entries':        1,                                                                                    # the number of cl_platform_id entries that can be added to platforms
#       'list2platforms':     ['DragonXi'],                                                                         # list = a list of OpenCL platforms
#       'available2platform': 1                                                                                     # the number of OpenCL platforms available
#      } 
#
#    try:                               
#        response4set2platformids = set2platformids4xi(task4set2platformids)                                        # or response2xi = set2platformids4xi() <-- let the system decide!
#                                                                                                                   
#    except:
#        ... 
#                          
#">

# -------------------------------------------------------------------------------------------------   
def set2platformids4xi(task4set2platformids=None):

    '''
    sets platformids4xi
    '''
    global ids2platform4xi  
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/3)           
    # -----------------------------------------------------------------------------------------          
    class2print = "set2platformids4xi"
    method2print = "set2platformids4xi"

    message2print = "{(Step 1/3a) started" + "; set2platformids4xi-started: " + str(set2platformids4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
  
             
    message2print = "{(Step 1/3b) passed" + "; task4set2platformids-to-set2platformids4xi: " + str(task4set2platformids) + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)                                                             # {     'list2platforms': ['Platform42', 'Platform43'], 
                                                                                                                   #   'available2platform': 44, 
                                                                                                                   #          'max2entries': 41
                                                                                                                   #}; time: 00:58:48 04/27/11 Pacific Daylight Time}


             
    if task4set2platformids is None:
        task4set2platformids = {}
        task4set2platformids['max2entries']        = 1                                                             # the number of cl_platform_id entries that can be added to platforms
        task4set2platformids['list2platforms']     = ['DragonXi']                                                  # a list of OpenCL platforms found
        task4set2platformids['available2platform'] = 1                                                             # the number of OpenCL platforms available
 
    
    ids2platform4xi = {}
    code2ack  = ' '
    code2nack = ' '
                        
    # -----------------------------------------------------------------------------------------
    # (Step 2/3)       
    # -----------------------------------------------------------------------------------------                  
    message2print = "{(Step 2A/3) try" + "; task4set2platformids-try-by-set2platformids4xi: " + str(task4set2platformids)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print)        
    
    try:
        # -----------------------------------------------------------------------------------------
        # MAXIMUM ENTRIES
        # ----------------------------------------------------------------------------------------- 
        if task4set2platformids ['max2entries'] is None:
            ids2platform4xi['max2entries'] = 1
            message2print = "{(Step 2B/3) set" + "; max2entries-set-by-set2platformids4xi to: " + str(ids2platform4xi ['max2entries'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                      # 
            code2ack  = code2ack + '2B-'
        else:
            ids2platform4xi['max2entries'] = task4set2platformids ['max2entries']
            message2print = "{(Step 2C/3) set" + "; max2entries-set-by-set2platformids4xi to: " + str(ids2platform4xi ['max2entries'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                      # 41 
            code2ack  = code2ack + '2C-'      
    except:
        message2print = "{(Step 2Z1/3) failed" + "; ids2platform4xi-failed-by-set2platformids4xi: " + str(ids2platform4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)          
        code2nack  = code2nack + '2Z1-'
    try: 
        # -----------------------------------------------------------------------------------------
        # MAXIMUM ENTRIES
        # -----------------------------------------------------------------------------------------                  
        if task4set2platformids ['max2entries'] == 0:
            ids2platform4xi ['max2entries'] = 1
            message2print = "{(Step 2D/3) set" + "; max2entries-set-by-set2platformids4xi to: " + str(ids2platform4xi ['max2entries'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            code2ack  = code2ack + '2D-'
        else:
            ids2platform4xi ['max2entries'] = task4set2platformids ['max2entries']                                  
            message2print = "{(Step 2E/3) set" + "; max2entries-set-by-set2platformids4xi to: " + str(ids2platform4xi ['max2entries'])  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)                                                      # 41  
            code2ack  = code2ack + '2E-'          
    except: 
        message2print = "{(Step 2Z2/3) failed" + "; ids2platform4xi-failed-by-set2platformids4xi: " + str(ids2platform4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        code2nack  = code2nack + '2Z2-'          
    
    try: 
        # -----------------------------------------------------------------------------------------
        # LIST OF PLATFORMS
        # -----------------------------------------------------------------------------------------                                    
        ids2platform4xi ['list2platforms'] = task4set2platformids ['list2platforms']
        message2print = "{(Step 2F/3) set" + "; list2platforms-set-by-set2platformids4xi to: " + str(ids2platform4xi ['list2platforms'])  + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # ['Platform42', 'Platform43']
        code2ack  = code2ack + '2F-' 
    except:
        message2print = "{(Step 2Z3/3) failed" + "; ids2platform4xi-failed-by-set2platformids4xi: " + str(ids2platform4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
        code2nack  = code2nack + '2Z3-'
         
    try: 
        # -----------------------------------------------------------------------------------------
        # AVAILABLE PLATFORMS
        # -----------------------------------------------------------------------------------------                
        ids2platform4xi ['available2platform'] = task4set2platformids ['available2platform']            
        message2print = "{(Step 2G/3) set" + "; available2platform-set-by-set2platformids4xi to: " + str(ids2platform4xi ['available2platform'])  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          # 44
        code2ack  = code2ack + '2G-'
    except:
        message2print = "{(Step 2Z4/3) failed" + "; ids2platform4xi-failed-by-set2platformids4xi: " + str(ids2platform4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
        code2nack  = code2nack + '2Z4-'                                                              
        

    # -----------------------------------------------------------------------------------------
    # (Step 3/3)           
    # -----------------------------------------------------------------------------------------
    ids2platform4xi ['ack2return']  = code2ack
    ids2platform4xi ['nack2return'] = code2nack
    
    message2print = "{(Step 3/3) returning" + "; ids2platform4xi-returning-by-set2platformids4xi: " + str(ids2platform4xi) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                              # {    'list2platforms': ['DragonXi'], 
                                                                                                                    #          'ack2return': ' 2C2E2F2G', 
                                                                                                                    #         'nack2return': ' ',
                                                                                                                    #  'available2platform': 1, 
                                                                                                                    #         'max2entries': 1
                                                                                                                    # }; time: 01:50:40 04/27/11 Pacific Daylight Time}


       
    
    return ids2platform4xi
            
#</function4xi>
 

# -------------------------------------------------------------------------------------------------
#<function4xi function = "get2platformids4xi" usage = "
#
#    try:                               
#        response4get2platformids = get2platformids4xi()                                        
#                                                                                                                   
#    except:
#        ... 
#                          
#">

# -------------------------------------------------------------------------------------------------   
def get2platformids4xi():

    '''
    gets platformids4xi
    '''
    global ids2platform4xi
    
    # -----------------------------------------------------------------------------------------
    # (Step 1/2)           
    # -----------------------------------------------------------------------------------------          
    class2print = "get2platformids4xi"
    method2print = "get2platformids4xi"

    message2print = "{(Step 1A/2) started" + "; get2platformids-started: " + str(get2platformids4xi)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    # <function get2platformids4xi at 0x0000000002A50748>; time: 20:09:14 05/11/11 Pacific Daylight Time}
    
    ids2return = None
    message2print = "{(Step 1A/2) set" + "; ids2return-set-by-get2platformids to: " + str(ids2return)  + "; time: " + time4xi() + "}"
    print4xi(class2print, method2print, message2print) 
    # None; time: 20:09:14 05/11/11 Pacific Daylight Time
    
    try:    
        if ids2platform4xi is None:
            message2print = "{(Step 1B/2) trying" + "; ids2return-trying-by-get2platformids: " + str(ids2return)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)   
     
            try:
                ids2return = init2platformids4xi()
                message2print = "{(Step 1C/2) got" + "; ids2return-got-by-get2platformids: " + str(ids2return)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)
            except:
                ids2return = None 
                message2print = "{(Step 1Z1/2) yielded" + "; ids2return-yielded-by-get2platformids: " + str(ids2return)  + "; time: " + time4xi() + "}"
                print4xi(class2print, method2print, message2print)    
        else:
            ids2return = ids2platform4xi    
            message2print = "{(Step 1E/2) got" + "; ids2return-got-by-get2platformids: " + str(ids2return)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
    except:
        try:
            ids2return = init2platformids4xi()
            message2print = "{(Step 1D/2) got" + "; ids2return-got-by-get2platformids: " + str(ids2return)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print)
            # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}; time: 20:18:34 05/11/11 Pacific Daylight Time}

        except:
            message2print = "{(Step 1Z2/2) yielded" + "; ids2return-yielded-by-get2platformids: " + str(ids2return)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
               
    message2print = "{(Step 2/2) returning" + "; ids2return-returning-by-get2platformids: " + str(ids2return) + "; time: " + time4xi() + "}" 
    print4xi(class2print, method2print, message2print)                                                             
    # {'list2platforms': ['DragonXi'], 'ack2return': ' 2C2E2F2G', 'nack2return': ' ', 'available2platform': 1, 'max2entries': 1}; time: 20:18:34 05/11/11 Pacific Daylight Time}

    
    return ids2return
            
#</function4xi>
 
                                               
# =================================================================================================
#<class4xi class = "PlatformID4Xi" base = "object" child = "None"
#   synopsis = "offers  methods for Platform IDs" usage = "OpenCL Platform Info"
#>

# =================================================================================================
class PlatformID4Xi(object): 
    ''' 
    PlatformID4Xi offers methods for Platform IDs
    '''            

    #                                        
    # ---------------------------------------------------------------------------------------------
    # sharable class variables
    # ---------------------------------------------------------------------------------------------      
    #<share4xi share = " 
    classvariable2platform = None
    #"
    #/>
        
    # ---------------------------------------------------------------------------------------------
    # Public API of this class
    # ---------------------------------------------------------------------------------------------    
    #<expose4xi expose = "
    _exposed_ = (
    'init2platformids',
    'get2platformids',
    'set2platformids',
    'sense',
    'reason',
    'ace')          
    #"
    #/>
 
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-PlatformID4Xi" usage = "initializes PlatformID4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def __init__(self, task4init2platformids = None):
        '''
        _init__ method initializes PlatformID4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/3)           
        # -----------------------------------------------------------------------------------------
                    
        class2print = "PlatformID4Xi"
        method2print = "__init__"
                     
        message2print = "{(Step 1/3a) started" + "; init-of-PlatformID4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   

        message2print = "{(Step 1/3b) borning" + "; platformid2xi-of-PlatformID4Xi-borning: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)       
                
        message2print = "{(Step 1/3c) inheriting" + "; object-inheriting-by-platformid2xi-of-PlatformID4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          # <class 'object'>         
        
        message2print = "{(Step 1/3d) sharing" + "; classvariable2platform-sharing-by-platformid2xi-of-PlatformID4Xi: " + str(PlatformID4Xi.classvariable2platform)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
                                
        message2print = "{(Step 1/3e) passed" + "; task4init2platformids-passed-to-init-of-PlatformID4Xi: " + str(task4init2platformids) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                                          # {'list2platforms': ['Platform52', 'Platform53'], 'available2platform': 54, 'max2entries': 51}; time: 00:58:48 04/27/11 Pacific Daylight Time}
                                  
        
        # -----------------------------------------------------------------------------------------
        # (Step 2/3)             
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2/3a) passing" + "; task4init2platformids-passing-to-init2platformids4xi-by-init-of-PlatformID4Xi: " + str(task4init2platformids) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
        
        platformids2xi = init2platformids4xi(task4init2platformids)
        
        message2print = "{(Step 2/3b) performed" + "; init2platformids4xi-performed-by-init-of-PlatformID4Xi: " + str(init2platformids4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                        
        # -----------------------------------------------------------------------------------------
        # (Step 3/3)             
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 3/3a) activated" + "; platformid2xi-of-PlatformID4Xi-activated: " + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)  
                
        message2print = "{(Step 3/3b) inherited" + "; object-inherited-by-platformid2xi-of-PlatformID4Xi: " + str(object)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
        message2print = "{(Step 3/3c) shared" + "; classvariable2platform-shared-by-platformid2xi-of-PlatformID4Xi: " + str(PlatformID4Xi.classvariable2platform)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                      
       
        message2print = "{(Step 3/3d) returning" + "; init-of-PlatformID4Xi-returning: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print) 
        

    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "init-of-PlatformID4Xi" usage = "initializes objects of PlatformID4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def init2platformids(self, task4init2platformids = None):
        '''
        init2platformids method initializes objects of PlatformID4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/3)           
        # -----------------------------------------------------------------------------------------              
        class2print = "PlatformID4Xi"
        method2print = "init2platformids"
                     
        message2print = "{(Step 1/3a) started" + "; init-of-PlatformID4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1/3b) passed" + "; task4init2platformids-passed-to-init-of-PlatformID4Xi: " + str(task4init2platformids) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/3)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2/3a) passing" + "; task4init2platformids-passing-to-init2platformids4xi-by-init-of-PlatformID4Xi: " + str(task4init2platformids) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
  
        platformids2xi = init2platformids4xi(task4init2platformids)

        message2print = "{(Step 2/3b) performed" + "; init2platformids4xi-performed-by-init-of-PlatformID4Xi: " + str(init2platformids4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/3)           
        # ----------------------------------------------------------------------------------------- 
        message2print = "{(Step 2/2) returning" + "; platformids2xi-returning-by-init2platformids-of-PlatformID4Xi: " + str(platformids2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          #  {    'list2platforms': ['Platform52', 'Platform53'], 
                                                                                                                    #           'ack2return': ' 2C2E2F2G', 
                                                                                                                    #          'nack2return': ' ', 
                                                                                                                    #   'available2platform': 54, 
                                                                                                                    #          'max2entries': 51
                                                                                                                    # }; time: 01:50:40 04/27/11 Pacific Daylight Time}

                
        return platformids2xi
                                
                            
    #</methodize4xi>
    

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "set2platformids-of-PlatformID4Xi" usage = "sets objects of PlatformID4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def set2platformids(self, task4set2platformids = None):
        '''
        set2platformids method sets objects of PlatformID4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/3)           
        # -----------------------------------------------------------------------------------------              
        class2print = "PlatformID4Xi"
        method2print = "set2platformids"
                     
        message2print = "{(Step 1/3a) started" + "; set2platformids-of-PlatformID4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            
        message2print = "{(Step 1/3b) passed" + "; task4set2platformids-passed-to-set2platformids-of-PlatformID4Xi: " + str(task4set2platformids) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)                                      
          
        # -----------------------------------------------------------------------------------------
        # (Step 2/3)           
        # -----------------------------------------------------------------------------------------
        message2print = "{(Step 2/3a) passing" + "; task4set2platformids-passing-to-set-get2platformids4xi-by-set2platformids-of-PlatformID4Xi: " + str(task4set2platformids) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)            
                
  
        platformids2xi = set2platformids4xi(task4set2platformids)

        message2print = "{(Step 2/3b) performed" + "; set-get2platformids4xi-performed-by-set2platformids-of-PlatformID4Xi: " + str(set2platformids4xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)             
                                
        # -----------------------------------------------------------------------------------------
        # (Step 3/3)           
        # ----------------------------------------------------------------------------------------- 
       
        message2print = "{(Step 2/2) returning" + "; platformids2xi-returning-by-set2platformids-of-PlatformID4Xi: " + str(platformids2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # {      'list2platforms': ['Platform62', 'Platform63'], 
                                                                                                                    #            'ack2return': ' 2C2E2F2G', 
                                                                                                                    #           'nack2return': ' ', 
                                                                                                                    #    'available2platform': 64, 
                                                                                                                    #           'max2entries': 61
                                                                                                                    # }; time: 01:50:40 04/27/11 Pacific Daylight Time}

                
        return platformids2xi
                                
                            
    #</methodize4xi>

    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "get2platformids-of-PlatformID4Xi" usage = "gets objects of PlatformID4Xi">
    
    # ---------------------------------------------------------------------------------------------   
    def get2platformids(self):
        '''
        get2platformids method gets objects of PlatformID4Xi
        ''' 
        
        # -----------------------------------------------------------------------------------------
        # (Step 1/2)           
        # -----------------------------------------------------------------------------------------              
        class2print = "PlatformID4Xi"
        method2print = "get2platformids"
                     
        message2print = "{(Step 1/2) started" + "; get2platformids-of-PlatformID4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
            

        # -----------------------------------------------------------------------------------------
        # (Step 2/2)           
        # ----------------------------------------------------------------------------------------- 
        platformids2xi = get2platformids4xi()
        
        message2print = "{(Step 2/2) returning" + "; platformids2xi-returning-by-get2platformids-of-PlatformID4Xi: " + str(platformids2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)                                                          # {      'list2platforms': ['Platform62', 'Platform63'], 
                                                                                                                    #            'ack2return': ' 2C2E2F2G', 
                                                                                                                    #           'nack2return': ' ', 
                                                                                                                    #    'available2platform': 64, 
                                                                                                                    #           'max2entries': 61
                                                                                                                    #  }; time: 01:50:40 04/27/11 Pacific Daylight Time}

                
        return platformids2xi
                                
                            
    #</methodize4xi>                                     
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "sense-of-PlatformID4Xi" usage = "senses PlatformID4Xi class objects">
    
    # ---------------------------------------------------------------------------------------------
    def sense(self):
        '''
        method sense: senses PlatformID4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'PlatformID4Xi'
        method2print = 'sense'
        
                     
        message2print = "{(Step 1/6) started" + "; sense-of-PlatformID4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------  
        
        message2print = "{(Step 2/6) sensing" + "; PlatformID4Xi-sensing-by-sense-of-PlatformID4Xi: " + str(PlatformID4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                        
        
        # -----------------------------------------------------------------------------------------
        # get sensed knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb2xi = sense_object4xi(self)
        
        message2print = "{(Step 3/6) got" + "; kb2xi-got-by-sense-of-PlatformID4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb2xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------         
        try:
            kb2xi['classvariable2platform-of-PlatformID4Xi'] = PlatformID4Xi.classvariable2platform
        except:
            message2print = "{(Step 4/6) yielded" + "; kb2xi-yielded-by-sense-of-PlatformID4Xi: " + str(kb2xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
            
      
        message2print = "{(Step 5/6) sensed" + "; PlatformID4Xi-sensed-by-sense-of-PlatformID4Xi: " + str(PlatformID4Xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)    
        
        # -----------------------------------------------------------------------------------------
        # 
        # -----------------------------------------------------------------------------------------         
        
        message2print = "{(Step 6/6) returning" + "; kb2xi-returning-by-sense-of-PlatformID4Xi: " + str(kb2xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                
          
        return kb2xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
    #</methodize4xi>
    
        
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "reason-of-PlatformID4Xi" usage = "reasons PlatformID4Xi class objects">
    
    # ---------------------------------------------------------------------------------------------
    def reason(self):
        '''
        method reason: reasons PlatformID4Xi class objects
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # ----------------------------------------------------------------------------------------- 
        class2print = 'PlatformID4Xi'
        method2print = 'reason'

                     
        message2print = "{(Step 1/6) started" + "; reason-of-PlatformID4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
          
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2/6) reasoning" + "; PlatformID4Xi-reasoning-by-reason-of-PlatformID4Xi: " + str(PlatformID4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print) 
                
        
        # -----------------------------------------------------------------------------------------
        # get reasoned knowledge for this object
        # -----------------------------------------------------------------------------------------         
        
        kb4xi = reason_object4xi(self)
        
        
        message2print = "{(Step 3/6) got" + "; kb4xi-got-by-reason-of-PlatformID4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                
        
        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb4xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------          
        try:
            kb4xi['time-reason-of-PlatformID4Xi'] = time4xi() #adding time
        except:
            message2print = "{(Step 4/6) yielded" + "; kb4xi-yielded-by-reason-of-PlatformID4Xi: " + str(kb4xi)  + "; time: " + time4xi() + "}"
            print4xi(class2print, method2print, message2print) 
        
          
        
        message2print = "{(Step 5/6) reasoned" + "; PlatformID4Xi-reasoned-by-reason-of-PlatformID4Xi: " + str(PlatformID4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)        
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        
        message2print = "{(Step 6/6) returning" + "; kb4xi-returning-by-reason-of-PlatformID4Xi: " + str(kb4xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                
          
        return kb4xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
    
    
    # ---------------------------------------------------------------------------------------------
    #<methodize4xi method = "ace-of-PlatformID4Xi" usage = "aces PlatformID4Xi class objects">
    
    # ---------------------------------------------------------------------------------------------
    def ace(self):
        '''
        method ace: aces PlatformID4Xi class objects 
        '''
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------       
        
        
        class2print = 'PlatformID4Xi'
        method2print = 'ace'
        
                     
        message2print = "{(Step 1/6) started" + "; ace-of-PlatformID4Xi-started: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)   
              
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------
        
        message2print = "{(Step 2/6) acing" + "; PlatformID4Xi-acing-by-ace-of-PlatformID4Xi: " + str(PlatformID4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
                    
        
        # -----------------------------------------------------------------------------------------
        # get aced knowledge for this object
        # -----------------------------------------------------------------------------------------        
        
        kb8xi = ace_object4xi(self)  
        
        message2print = "{(Step 3/6) got" + "; kb8xi-got-by-ace-of-PlatformID4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)
                


        # -----------------------------------------------------------------------------------------
        # add knowledge specific to this object
        # format example: kb8xi['time2xi'] = time4xi() #adding time 
        # -----------------------------------------------------------------------------------------              
        try:
             kb8xi['time-ace-of-PlatformID4Xi'] = time4xi()
        except:
             message2print = "{(Step 4/6) yielded" + "; kb8xi-yielded-by-ace-of-PlatformID4Xi: " + str(kb8xi)  + "; time: " + time4xi() + "}"
             print4xi(class2print, method2print, message2print) 
  
        message2print = "{(Step 5/6) aced" + "; PlatformID4Xi-aced-by-ace-of-PlatformID4Xi: " + str(PlatformID4Xi) + "; time: " + time4xi() + "}"
        print4xi(class2print, method2print, message2print)         
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------        
        message2print = "{(Step 6/6) returning" + "; kb8xi-returning-by-ace-of-PlatformID4Xi: " + str(kb8xi) + "; time: " + time4xi() + "}" 
        print4xi(class2print, method2print, message2print)    
                                  
        
        return kb8xi
        
        # -----------------------------------------------------------------------------------------
        #
        # -----------------------------------------------------------------------------------------            
    #</methodize4xi>
#</class4xi>
#</program4xi>

# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_get2platformids4xi.txt
#   sense-test-get2platformids4xi.xml
#   reason-test-get2platformids4xi.xml
#   ace-test-get2platformids4xi.xml
#"
#>

#<acknowledge4xi acknowledgement = "33" tester = "Small & Smart"/>


# -------------------------------------------------------------------------------------------------
# to-be-done                              
# -------------------------------------------------------------------------------------------------    
#<do4xi do = "
# None
#"
#/>

#<note4xi note = "
# parse4xi.py - to parse this module
# "/>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of platformids4xi.py                              
# ------------------------------------------------------------------------------------------------- 
#"
#/>
